#------------------------------------------------------------------
#
# Module      : kxcosrca.mak
#
# Description : KXC C++ Object Model common makefile, contains
#               targets and file lists for which are common
#               across platforms.
#
# Notes       : Don't use this makefile directly, it is included
#               from the main makefile.
#
#------------------------------------------------------------------
#
# Copyright(C) Candle Corporation, 2001-2003.
#
#------------------------------------------------------------------
# $Id: kxcosrca.mak,v 1.9 2004/01/22 17:53:26 e_dm Exp $
# $Source: /romacvs/root/roma/src/kxc/omodel/cpp/kxcosrca.mak,v $
#------------------------------------------------------------------

#------------------------------------------------------------------
# The objects that make up the object model library
#------------------------------------------------------------------
KXCOOBJ= \
     kxcoierr.$(O) kxcoigdt.$(O) kxcoiopt.$(O) kxcoimsg.$(O)        \
     kxcoicxt.$(O) kxcoidir.$(O) kxcopbl.$(O)  kxcosbs.$(O)         \
     kxcobea.$(O)  kxcocrsa.$(O) kxcotba.$(O)  kxcolia.$(O)         \
     kxcosbla.$(O) kxcothma.$(O) kxcotsa.$(O)  kxcocla.$(O)         \
     kxcoseca.$(O) kxcobrqa.$(O) kxcoema.$(O)  kxcomida.$(O)        \
     kxcosoa.$(O)  kxcotrca.$(O) kxcobrsa.$(O) kxcoerra.$(O)        \
     kxcostqa.$(O) kxcoutil.$(O) kxcogtoa.$(O) kxcosyna.$(O)        \
     kxcorda.$(O)  kxcosuba.$(O) kxcocrqa.$(O) kxcoils.$(O)         \
     kxcorvoa.$(O) kxcodac.$(O)  kxcoiems.$(O) kxcoems.$(O)         \
    $(KXCOPLATOBJ)


$(KXCOOBJ) : \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxco.hpp         \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoall.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcobe.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcobrq.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcobrs.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcocl.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcocrq.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcocrs.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcodac.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoem.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoenv.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoerr.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcogto.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoils.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoli.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcomid.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcopbl.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcorda.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoroma.hpp     \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcorvo.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcosbl.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcosbs.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcosec.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoso.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcostq.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcosub.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcosyn.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcotb.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcothm.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcotrb.hpp      \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcots.hpp       \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoutil.hpp     \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcxit.h         \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcamac.h        \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcenv.h         \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxc.h            \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcutl.h         \
  $(CANDLE_CASP_HOME)$(D)toolkit$(D)include$(D)kxcoenv.hpp      \
  kxcointa.hpp kxcotrc.hpp kxcoimsg.hpp kxcoicxt.hpp            \
  kxcoierr.hpp kxcoigdt.hpp kxcoiopt.hpp kxcoidir.hpp kxcodefs.hpp \
  kxcoipxy.hpp kxcoplth.hpp  kxcopltn.hpp  kxcoplts.hpp  kxcopltx.hpp
