//--------------------------------------------------------------------
//
// Copyright Candle Corporation 2001-2003
//
// This code is the confidential and proprietary property of Candle
// Corporation that is licensed for your internal company use only
// and is not to be reproduced, used, licensed, sold or disclosed
// outside of your corporation except upon written authorization of
// Candle Corporation. The code can be used for internal development,
// test and production applications.  Any unauthorized use,
// duplication, or disclosure is unlawful. You may not sell or license
// this code in any commercial products.
//
// Permission is granted to you to alter the code for your internal
// use only, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
//    not claim that you wrote the code.  If you use this code in
//    conjunction with other code, an acknowledgement is required.
//
// 2. Altered versions of this code must be plainly marked as such,
//    and must not be misrepresented as being the original code.
//
// 3. This notice may not be removed or altered from any source
//    distribution.
//
// This code is provided with RESTRICTED RIGHTS.  Use, duplication or
// disclosure by the Government is subject to restrictions set forth
// in the applicable license agreement and/or Government Data Rights
// Clauses(s), as applicable (including but not limited to DFARS
// 252.227-7013(c)(ii) and FAR 52.227-19(a)(d).  Unpublished-All
// rights reserved under United States Copyright Laws.  Manufacturer
// is Candle Corporation, 100 N. Sepulveda Boulevard, El Segundo, CA 90245.
//
//--------------------------------------------------------------------
//
// Module       : RomaDirectoryAccess.java
//
// Defines      : class RomaDirectoryAccess
//
//--------------------------------------------------------------------

package com.candle.roma.kxc;

import java.io.*;
import java.lang.*;

/**
* This class encapsalates LDAP authentication information.
*/

public class RomaDirectoryAccess
{
  private static final String copyrightNotice =
    "Copyright Candle Corporation 2001-2002";

  private String m_id;
  private String m_pwd;


  /**
  * Default constructor
  */
  public RomaDirectoryAccess()
  {
  }

  /**
  * Initializing constructor
  *
  * Both, user ID and password must be set.
  *
  * @param id User ID.
  * @param pwd Password.
  */
  public RomaDirectoryAccess( String id, String pwd )
  {
    m_id = id;
    m_pwd = pwd;
  }

  /**
  * Retrieves the user ID
  *
  * @return   String containing an user ID
  */
  public String getUserId()
  {
    return m_id;
  }

  /**
  * Set the user ID
  *
  * @param id User ID.
  */
  public void setUserId( String id )
  {
    m_id = id;
  }

  /**
  * Retrieves the password
  *
  * @return   String containing a password
  */
  public String getPassword()
  {
    return m_pwd;
  }

  /**
  * Set the password
  *
  * @param pwd Password.
  */
  public void setPassword( String pwd )
  {
    m_pwd = pwd;
  }
}
