VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "EMS Server sample"
   ClientHeight    =   5040
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   ScaleHeight     =   5040
   ScaleWidth      =   7560
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   6240
      Top             =   2400
   End
   Begin VB.CommandButton BStart 
      Caption         =   "Start"
      Height          =   492
      Left            =   5760
      TabIndex        =   9
      Top             =   3000
      Width           =   1692
   End
   Begin VB.CommandButton BStop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   492
      Left            =   5760
      TabIndex        =   8
      Top             =   3600
      Width           =   1692
   End
   Begin VB.CommandButton BQuit 
      Caption         =   "Quit"
      Height          =   492
      Left            =   5760
      TabIndex        =   7
      Top             =   4440
      Width           =   1692
   End
   Begin VB.CheckBox CBVerbose 
      Alignment       =   1  'Right Justify
      Caption         =   "Verbose"
      Height          =   492
      Left            =   5760
      TabIndex        =   6
      Top             =   1680
      Value           =   1  'Checked
      Width           =   1692
   End
   Begin VB.ComboBox CBAction 
      Height          =   288
      ItemData        =   "kxcxsems.frx":0000
      Left            =   5760
      List            =   "kxcxsems.frx":000A
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   1080
      Width           =   1692
   End
   Begin VB.TextBox TBName 
      Height          =   288
      Left            =   5760
      TabIndex        =   1
      Text            =   "TestElementEMS"
      Top             =   360
      Width           =   1692
   End
   Begin VB.TextBox TBOutput 
      Height          =   4572
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   360
      Width           =   5532
   End
   Begin VB.Label Label3 
      Caption         =   "Action"
      Height          =   252
      Left            =   5760
      TabIndex        =   5
      Top             =   840
      Width           =   1332
   End
   Begin VB.Label Label2 
      Caption         =   "Element name"
      Height          =   252
      Left            =   5760
      TabIndex        =   3
      Top             =   120
      Width           =   1692
   End
   Begin VB.Label Label1 
      Caption         =   "Server output"
      Height          =   252
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   3012
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------------
'
' Copyright Candle Corporation 2004
'
' Disclaimer:  This sample program is provided for
'              information purposes only.  Candle neither makes
'              any warranties or representations regarding this
'              software, or its use.  This sample program is
'              provided "as is" and Candle expressly disclaims the
'              warranties of merchantability and fitness for a
'              particular purpose.
'
'--------------------------------------------------------------------
'
' Description:
'    Sample Roma C++ EMS Server Program.
'
'    This program shows a very simple Roma EMS server in action.
'    It is intended to show representative usage of the Roma
'    ActiveX EMS API.
'
' Details:
'    This program reads EMS messages from its input queue, and
'    processes them.
'    It can browse and display the contents of the EMS messages,
'    or it can modify the user-message data and return the message
'    back onto the queue on which the reported operation failed.
'    So, for example, if a Roma server application fails to GET
'    a message from its input queue (for whatever reason), and
'    Error Profiling is configured to cause an EMS message to be
'    sent to this EMS server, then the EMS server can modify the
'    message data and return the message back to the Roma server's
'    input queue to allow it to re-attempt the GET operation.
'    If a PUT operation to a specific queue fails, and an EMS
'    message is set to this EMS server, then it will again replace
'    the message data and attempt to PUT the message onto the
'    original target queue again.
'
' Dependencies:
'    Requires the relevant services to be set up in the directory
'    and the underlying transport queues to be configured in
'    support of the routes defined for the directory entry.
'    Error Profiling needs to be configured to have EMS as the
'    required action, and the Busines Service representing this
'    EMS server to be the EMSServer that is used.
'
'--------------------------------------------------------------------
' $Id: kxcxsems.frm,v 1.2 2004/01/27 19:07:37 e_dm Exp $
' $Source: /romacvs/root/roma/src/kxc/omodel/activex/kxcxsems.frm,v $
'--------------------------------------------------------------------

Option Explicit

' Server connection
Public elem As New RomaBusinessElement

' Maximal retry count
Public maxRetry As Long

' Output separator
Public sep As String


' Peeks messages from the queue and prints their information
Private Sub DisplayMsg()
    Dim info As RomaMessageInfo
    Dim request As RomaBeRequest
    Dim options As New RomaGetOptions
    Dim theme As Long
    
    ' Setup GET options
    
    ' Prohibit EAR intervention
    options.NoEms = True
    ' Accept native messages
    options.AllowNative = True
    ' Close the recieved message theme
    options.CloseTheme = True
    ' Don't wait for a message
    options.WaitInterval = 0
    ' Leave messages on the queue
    options.Operation = ROMA_GET_OPERATION_PEEK_FIRST
    
    PrintLine vbNewLine & "Roma Exception Message Display"
    PrintLine sep & vbNewLine
    
    ' Get a message
    Set request = elem.Get(options)
    
    Do While Not request Is Nothing
        ' Extract detailed message information
        Set info = elem.InterpretMessage(request, ROMA_INTMSG_THEME)
        
        ' Print message information
        PrintLine "Message received. Processing ..." & vbNewLine
        PrintMsgInfo info, request
        PrintLine sep & vbNewLine
        
        ' It is application responsibility to close the extracted theme
        theme = info.theme
        If Not theme = 0 Then
            elem.CloseTheme theme
        End If
        
        ' Get the next message
        options.Operation = ROMA_GET_OPERATION_PEEK_NEXT
        Set request = elem.Get(options)
    Loop

    PrintLine "No more messages"
End Sub


' Updates the theme workflow and returns the message to the sender
Private Sub ReturnMsg()
    Dim info As RomaMessageInfo
    Dim request As RomaBeRequest
    Dim options As New RomaGetOptions
    Dim theme As Long
    Dim ti As RomaThemeInfo
    Dim wflow As RomaWorkflow
    Dim rlist As RomaRouteList
    Dim route As RomaRoute
    Dim rebuild As Boolean
    Dim exc As RomaExceptionInfo
    Dim edata As RomaExcErrorData
    Dim rc As RomaConfig
    Dim response As New RomaBeResponse
    
    ' Setup GET options
    
    ' Prohibit EAR invokation
    options.NoEms = True
    ' Accept native messages
    options.AllowNative = True
    ' Close the recieved message theme
    options.CloseTheme = True
    ' Don't wait for a message
    options.WaitInterval = 0
    
    ' Get a message
    Set request = elem.Get(options)
    
    If request Is Nothing Then
        Exit Sub
    End If
    
    If CBVerbose = vbChecked Then
        PrintLine "Message received. Processing ..."
    End If
    
    ' Extract detailed message information
    Set info = elem.InterpretMessage(request, ROMA_INTMSG_THEME)
        
    If Not info.HasTheme Then
        Err.Raise "No theme in the message information"
    End If
        
    ' Extract theme details
    theme = info.theme
    Set ti = elem.QueryTheme(theme)
        
    ' Check the retry count to prevent message bouncing
    If ti.RetryCount >= maxRetry Then
        Err.Raise "Retry count exceeded maximum"
    End If
        
    ' Check workflow route steps
    Set wflow = ti.Workflow
    Set rlist = wflow.Routes
        
    If rlist.IsEmpty Then
        Err.Raise "No routes in the workflow"
    End If
        
    rebuild = False
        
    ' Remove bridges from the route.
    ' The message will be sent to the first non-bridge application.
    Set route = rlist(0)
    Do Until route Is Nothing Or route.Type <> ROMA_APPTYPE_BRIDGE
        rlist.Remove 0
        rebuild = True
        Set route = rlist(0)
    Loop
        
    If rlist.IsEmpty Then
        Err.Raise "No routes in the workflow after bridges removal"
    End If
        
    ' Rebuild the workflow to put the message back to the
    ' sender's input queue.
    If info.HasException Then
        Set exc = info.Exception
        If exc.HasErrorData Then
            Set edata = exc.ErrorData
            If edata.callType = ROMA_CALLTYPE_GETREQUEST Or _
               edata.callType = ROMA_CALLTYPE_GETRESPONSE Then
                Set rc = exc.RomaConfig
                wflow.WorkflowService.Component = rc.ComponentName
                   
                Dim wr As New RomaRoute
                wr.Type = rc.ElementType
                wr.TargetQueue = rc.QueueName
                wr.TargetElement = rc.ElementName
                wr.TargetComponent = rc.ComponentName
                rlist.Insert wr, 0
                rebuild = True
            End If
        End If
    End If
        
    ' If the workflow route is modified, we need to build a new
    ' theme that will be used for the message return. The old
    ' theme should be closed.
    If rebuild Then
        If CBVerbose = vbChecked Then
            PrintLine "Rebuilding the theme ..."
        End If
            
        theme = elem.BuildTheme(theme, ti, ROMA_THEMEINFO_WORKFLOW, True)
    End If
        
    If CBVerbose = vbChecked Then
        Set route = rlist(0)
        PrintLine "Returning message to the application " & _
            route.TargetElement & " on the queue " & route.TargetQueue
    End If
                
    If info.HasMessage Then
        Set request = info.BeRequest
    End If
        
    ' Create the response message that will be put back onto the
    ' queue around which the original error occurred
        
    ' Use original message ID and correlation ID
    response.MsgId = request.MsgId
    response.CorrelId = request.CorrelId
    response.Selector = ROMA_PUT_SELECTOR_USE_MSGID_AND_CORRELID
    ' Set theme
    response.theme = theme
    ' Set message data
    response.SetMsgBuffer "MESSAGE-MODIFIED-BY-EMS"
    ' Close the theme when the message is sent
    response.CloseTheme = True
    ' Don't invoke error analysis services
    response.NoEms = True
    ' Don't put in a transactional queue
    response.NoSyncAllowed = True
    ' The server doesn't need a notfication
    response.NoNotification = True
    ' Prohibit a message transformation
    response.NoTransformation = True
    ' Enable the retry counter
    response.IncrementRetryCount = True
        
    ' Send the modified message
    elem.Put response
    
    If CBVerbose = vbChecked Then
        PrintLine sep & vbNewLine
    End If
End Sub


' Converts binary data to hexadecimal values string
Public Function bin2String(bin As Variant) As String
    Dim i As Long
    Dim s As String
    
    bin2String = ""
    
    For i = LBound(bin) To UBound(bin)
        s = Hex(CByte(bin(i)))
        
        If Len(s) < 2 Then
            s = "0" & s
        End If
        
        bin2String = bin2String & s
    Next i
End Function


' Adds line to the TBOutput text box
Private Sub PrintLine(str As String)
    TBOutput.SelLength = Len(TBOutput)
    TBOutput.SelText = str & vbNewLine
End Sub


' Converts application type to string
Private Function AppType2String(appType As ROMAAPPTYPE) As String
    Select Case appType
        Case ROMA_APPTYPE_BRIDGE
            AppType2String = "Bridge"
        Case ROMA_APPTYPE_CLIENT
            AppType2String = "Client"
        Case ROMA_APPTYPE_SERVER
            AppType2String = "Server"
        Case ROMA_APPTYPE_NATIVE_CLIENT
            AppType2String = "Native client"
        Case ROMA_APPTYPE_NATIVE_SERVER
            AppType2String = "Native server"
        Case Else
            AppType2String = "Unknown"
    End Select
End Function


' Converts environment type to string
Private Function EnvType2String(envType As ROMAENVTYPE) As String
    Select Case envType
        Case ROMA_ENVTYPE_INTEL
            EnvType2String = "Intel"
        Case ROMA_ENVTYPE_MVS
            EnvType2String = "MVS"
        Case ROMA_ENVTYPE_OS400
            EnvType2String = "OS/400"
        Case ROMA_ENVTYPE_UNIX
            EnvType2String = "Unix"
        Case ROMA_ENVTYPE_VMS
            EnvType2String = "VMS"
        Case Else
            EnvType2String = "Unknown"
    End Select
End Function


' Converts OS type to string
Private Function EnvOs2String(envType As ROMAENVOS) As String
    Select Case envType
        Case ROMA_ENVOS_AIX
            EnvOs2String = "AIX"
        Case ROMA_ENVOS_DUX
            EnvOs2String = "Digital Unix"
        Case ROMA_ENVOS_HPUX102, ROMA_ENVOS_HPUX11
            EnvOs2String = "HP-UX"
        Case ROMA_ENVOS_MVSBATCH
            EnvOs2String = "MVS batch job"
        Case ROMA_ENVOS_MVSCICS
            EnvOs2String = "MVS CICS"
        Case ROMA_ENVOS_OS400
            EnvOs2String = "OS/400"
        Case ROMA_ENVOS_SUN
            EnvOs2String = "SunOS"
        Case ROMA_ENVOS_WIN95, ROMA_ENVOS_WINNT
            EnvOs2String = "Windows"
        Case Else
            EnvOs2String = "Unknown"
    End Select
End Function


' Converts Roma call type to string
Private Function CallType2String(callType As Long) As String
    Select Case callType
        Case ROMA_CALLTYPE_APPLICATION
            CallType2String = "APPLICATION"
        Case ROMA_CALLTYPE_BRIDGEGET
            CallType2String = "BRIDGEGET"
        Case ROMA_CALLTYPE_BRIDGEPUT
            CallType2String = "BRIDGEPUT"
        Case ROMA_CALLTYPE_BUILDTHEME
            CallType2String = "BUILDTHEME"
        Case ROMA_CALLTYPE_CLOSEHANDLE
            CallType2String = "CLOSEHANDLE"
        Case ROMA_CALLTYPE_CLOSESTORAGEQ
            CallType2String = "CLOSESTORAGEQ"
        Case ROMA_CALLTYPE_COMMIT
            CallType2String = "COMMIT"
        Case ROMA_CALLTYPE_DELETESTORAGEQ
            CallType2String = "DELETESTORAGEQ"
        Case ROMA_CALLTYPE_DIRDELETEITEM
            CallType2String = "DIRDELETEITEM"
        Case ROMA_CALLTYPE_DIRGETDN
            CallType2String = "DIRGETDN"
        Case ROMA_CALLTYPE_DIRGETMODCOUNT
            CallType2String = "DIRGETMODCOUNT"
        Case ROMA_CALLTYPE_DIRLOOKUP
            CallType2String = "DIRLOOKUP"
        Case ROMA_CALLTYPE_DIRSETACCESS
            CallType2String = "DIRSETACCESS"
        Case ROMA_CALLTYPE_DIRUPDATEITEM
            CallType2String = "DIRUPDATEITEM"
        Case ROMA_CALLTYPE_FREEBUFFER
            CallType2String = "FREEBUFFER"
        Case ROMA_CALLTYPE_GETBUFFER
            CallType2String = "GETBUFFER"
        Case ROMA_CALLTYPE_GETERROR
            CallType2String = "GETERROR"
        Case ROMA_CALLTYPE_GETFROMSTORAGEQ
            CallType2String = "GETFROMSTORAGEQ"
        Case ROMA_CALLTYPE_GETILSDATA
            CallType2String = "GETILSDATA"
        Case ROMA_CALLTYPE_GETREQUEST
            CallType2String = "GETREQUEST"
        Case ROMA_CALLTYPE_GETRESPONSE
            CallType2String = "GETRESPONSE"
        Case ROMA_CALLTYPE_INITIALIZE
            CallType2String = "INITIALIZE"
        Case ROMA_CALLTYPE_INTERPRETMSG
            CallType2String = "INTERPRETMSG"
        Case ROMA_CALLTYPE_NUMCALLS
            CallType2String = "NUMCALLS"
        Case ROMA_CALLTYPE_OPENSTORAGEQ
            CallType2String = "OPENSTORAGEQ"
        Case ROMA_CALLTYPE_PURGEQTOEMS
            CallType2String = "PURGEQTOEMS"
        Case ROMA_CALLTYPE_PUTEXCEPTION
            CallType2String = "PUTEXCEPTION"
        Case ROMA_CALLTYPE_PUTREQUEST
            CallType2String = "PUTREQUEST"
        Case ROMA_CALLTYPE_PUTRESPONSE
            CallType2String = "PUTRESPONSE"
        Case ROMA_CALLTYPE_PUTTOSTORAGEQ
            CallType2String = "PUTTOSTORAGEQ"
        Case ROMA_CALLTYPE_QMGRCONNECT
            CallType2String = "QMGRCONNECT"
        Case ROMA_CALLTYPE_QUERY
            CallType2String = "QUERY"
        Case ROMA_CALLTYPE_QUERYCONTEXT
            CallType2String = "QUERYCONTEXT"
        Case ROMA_CALLTYPE_QUERYTHEME
            CallType2String = "QUERYTHEME"
        Case ROMA_CALLTYPE_REPORTERROR
            CallType2String = "REPORTERROR"
        Case ROMA_CALLTYPE_ROLLBACK
            CallType2String = "ROLLBACK"
        Case ROMA_CALLTYPE_SENDALERT
            CallType2String = "SENDALERT"
        Case ROMA_CALLTYPE_SETILSDATA
            CallType2String = "SETILSDATA"
        Case ROMA_CALLTYPE_SETLDAPSERVICE
            CallType2String = "SETLDAPSERVICE"
        Case ROMA_CALLTYPE_TERMINATE
            CallType2String = "TERMINATE"
        Case ROMA_CALLTYPE_WRITELOG
            CallType2String = "WRITELOG"
        Case ROMA_CALLTYPE_WRITESYSLOG
            CallType2String = "WRITESYSLOG"
        Case ROMA_CALLTYPE_XPORTDATA
            CallType2String = "XPORTDATA"
        Case Else
            CallType2String = "Unknown"
    End Select
End Function


' Converts trailer type to string
Private Function TrailerType2String(trType As Long) As String
    Select Case trType
        Case ROMA_ILS_TYPE_ERROR
            TrailerType2String = "ERROR"
        Case ROMA_ILS_TYPE_USER
            TrailerType2String = "USER"
        Case ROMA_ILS_TYPE_ROUTER
            TrailerType2String = "ROUTER"
        Case ROMA_ILS_TYPE_SYSMGMT
            TrailerType2String = "SYSMGMT"
        Case ROMA_ILS_TYPE_WEB
            TrailerType2String = "XML"
        Case ROMA_ILS_TYPE_XPTDATA
            TrailerType2String = "XPTDATA"
        Case ROMA_ILS_TYPE_XPORT
            TrailerType2String = "XPORT"
        Case Else
            TrailerType2String = "Unknown"
    End Select
End Function


' Prints exception data
Private Sub PrintExcInfo(info As RomaExceptionInfo)
    Dim rc As RomaConfig
    Dim sc As RomaSystemConfig
    Dim ed As RomaExcErrorData
    Dim re As RomaError
        
    PrintLine "  Exception Information :"
    
    ' If there is Roma configuration data, print it
    If info.HasRomaConfig Then
        Set rc = info.RomaConfig
        PrintLine "    Roma Configuration Information :"
        PrintLine "      Application Type : " & _
            AppType2String(rc.ElementType)
        PrintLine "      Application Name : " & rc.ElementName
        PrintLine "      Input Queue Name : " & rc.QueueName
        PrintLine "      Associated Business Component : " & rc.ComponentName
        PrintLine "      Associated Business Service : " & rc.ServiceName
        PrintLine "      Node Name : " & rc.NodeName
    Else
        PrintLine "    No Roma Configuration Information"
    End If
    
    ' If there is system configuration data, print it
    If info.HasSystemConfig Then
        Set sc = info.SystemConfig
        PrintLine "    System Configuration Information :"
        PrintLine "      Environment Type : " & _
            EnvType2String(sc.envType)
        PrintLine "    Environment OS : " & _
            EnvOs2String(sc.EnvOS)
        PrintLine "    Domain Name : " & sc.DomainName
        PrintLine "    User ID : " & sc.UserId
        PrintLine "    Program Name : " & sc.ProgramName
        PrintLine "    Process ID : " & Hex(sc.ProcessId)
        PrintLine "    Thread ID : " & Hex(sc.ThreadID)
    Else
        PrintLine "    No System Configuration Information"
    End If
    
    ' If there is a timestamp, print it
    If info.HasTimestamp Then
        PrintLine "    Timestamp : " & DateAdd("s", info.TimeStamp.Seconds, "1/1/1970")
    Else
        PrintLine "    No timestamp information"
    End If
    
    ' If there is error information, print it
    If info.HasErrorData Then
        Set ed = info.ErrorData
        Set re = ed.Error
        PrintLine "    Error Information : "
        PrintLine "      Primary : " & _
            re.ErrorText(ROMA_ERROR_SUBCLASS_PRIMARY)
        PrintLine "      Secondary : " & _
            re.ErrorText(ROMA_ERROR_SUBCLASS_SECONDARY)
        PrintLine "      Call Type : " & CallType2String(ed.callType)
        PrintLine "      Queue Name : " & ed.QueueName
    Else
        PrintLine "    No Error Information"
    End If
    
    ' If there is user data, print it
    If info.HasUserData Then
        PrintLine "    User Data : " & bin2String(info.UserData)
    Else
        PrintLine "    No User Data"
    End If
End Sub


' Prints workflow information
Private Sub PrintWorkflow(wf As RomaWorkflow)
    Dim route As RomaRoute
    Dim rlist As RomaRouteList
    Dim ws As RomaWorkflowService
    Dim num As Long
    
    ' Print workflow service data
    Set ws = wf.WorkflowService
    PrintLine vbNewLine & "  Workflow Information :"
    PrintLine "    Workflow Service Information :"
    PrintLine "      Current Service : " & ws.Service
    PrintLine "      Current Component : " & ws.Component
    PrintLine "      Audit : " & ws.Audit
    PrintLine "      Source Service : " & ws.SourceService
    PrintLine "      Source Business Flow : " & ws.SourceFlow
    PrintLine "      Source Operation :" & ws.SourceOperation
    
    ' Print workflow route steps
    Set rlist = wf.Routes
    
    If rlist.IsEmpty Then
        PrintLine "    No Route Information"
        Exit Sub
    End If
    
    PrintLine "    Route Information :"
    num = 1
    
    For Each route In rlist
        PrintLine "      Route #" & num & " :"
        PrintLine "        Type : " & AppType2String(route.Type)
        PrintLine "        Flags : " & Hex(route.Flags)
        PrintLine "        Target Queue : " & route.TargetQueue
        PrintLine "        Target Element : " & route.TargetElement
        PrintLine "        Target Component : " & route.TargetComponent
        PrintLine "        Target Code Page : " & route.TargetCodePage
        PrintLine "        Source Service : " & route.SourceService
        PrintLine "        Source Flow : " & route.SourceFlow
        PrintLine "        Source Operation : " & route.SourceOperation
        num = num + 1
    Next
End Sub


' Prints message data
Private Sub PrintMessage(msg As RomaBeRequest)
    PrintLine vbNewLine & "  Message Information :"
    PrintLine "    Format : " & msg.Format
    PrintLine "    Type : " & msg.MsgType
    PrintLine "    Persistence : " & msg.Persistence
    PrintLine "    Priority : " & msg.Priority
    PrintLine "    Feedback : " & msg.Feedback
    PrintLine "    Expiry : " & msg.Expiry
    PrintLine "    Code Page : " & msg.Codepage
    PrintLine "    Encoding : " & msg.Encoding
    PrintLine "    Status : " & msg.Status
    PrintLine "    Backout Count : " & msg.BackoutCount
    PrintLine "    Format Name : " & msg.FormatName
    PrintLine "    Message Name : " & msg.MsgName
    If msg.TimeStamp.Seconds <> 0 Then
        PrintLine "    Timestamp : " & _
            DateAdd("s", msg.TimeStamp.Seconds, "1/1/1970")
    End If
    PrintLine "    Message ID : " & bin2String(msg.MsgId)
    PrintLine "    Correl ID : " & bin2String(msg.CorrelId)
    PrintLine "    Tag Data : " & bin2String(msg.TagBuffer)
    PrintLine "    Message Data : " & bin2String(msg.MsgBuffer)
End Sub


' Prints theme information
Private Sub PrintTheme(info As RomaThemeInfo)
    Dim tlist As RomaTrailerList
    Dim trailer As RomaTrailer
    Dim num As Long
    
    PrintLine vbNewLine & "  Theme Information :"
    PrintLine "    Retry Count : " & info.RetryCount
    PrintLine "    Theme ID : " & bin2String(info.ThemeId)
    
    If (info.ConfirmFlags And ROMA_CONFIRMFLAG_ARRIVAL) <> 0 Then
        PrintLine "    Confirmation of Arrival is enabled"
    End If
    
    If (info.ConfirmFlags And ROMA_CONFIRMFLAG_DELIVERY) <> 0 Then
        PrintLine "    Confirmation of Delivery is enabled"
    End If
    
    Set tlist = info.Trailers
    
    If tlist.IsEmpty Then
        Exit Sub
    End If
    
    PrintLine "    Persistent Trailers :"
    num = 1
    
    For Each trailer In tlist
        PrintLine "      Trailer #" & num & " :"
        PrintLine "        Type : " & TrailerType2String(trailer.Type)
        PrintLine "        Method : " & trailer.Method
        PrintLine "        Data : " & bin2String(trailer.Data)
        num = num + 1
    Next
End Sub

' Prints message information
Private Sub PrintMsgInfo(info As RomaMessageInfo, request As RomaBeRequest)
    Dim theme As Long
        
    ' If there is exception information, print it
    If info.HasException Then
        PrintExcInfo info.Exception
    Else
        PrintLine " No exception information"
    End If
    
    ' If there is workflow information, print it
    If info.HasWorkflow Then
        PrintWorkflow info.Workflow
    Else
        PrintLine " No workflow information"
    End If
    
    ' If there is message data, print it.
    ' Otherwise, print the received message.
    PrintMessage IIf(info.HasMessage, info.BeRequest, request)
    
    ' If there is a theme, print its details
    If info.HasTheme Then
        theme = info.theme
        If theme = 0 Then
            PrintLine " Theme is NULL"
        Else
            PrintTheme elem.QueryTheme(theme)
        End If
    Else
        PrintLine " No Theme Information"
    End If
End Sub


Private Sub BQuit_Click()
    End
End Sub

Private Sub Form_Load()
    maxRetry = 5
    CBAction.ListIndex = 0
    sep = String(30, "_")
End Sub


Private Sub BStart_Click()
    On Error GoTo EH

    Form1.MousePointer = 11
    TBOutput = ""
    
    ' Initialize EMS server connection
    If Not elem.IsConnected Then
        PrintLine "Initializing EMS Server as " & TBName
        elem.Connect TBName
    End If
    
    PrintLine "Action is " & CBAction
    
    BStop.Enabled = True
    BStart.Enabled = False
    TBName.Enabled = False
    CBAction.Enabled = False
    
    If CBAction.ListIndex = 0 Then
        ' Action is DISPLAY
        DisplayMsg
        BStop_Click
    Else
        ' Action is RETURN
        PrintLine vbNewLine & "Roma Exception Message Return"
        PrintLine sep & vbNewLine
        Timer1.Enabled = True
    End If
    
    Form1.MousePointer = 0
    Exit Sub
    
EH:
    PrintLine vbNewLine & "ERROR:"
    PrintLine Err.Description
    Form1.MousePointer = 0
End Sub


Private Sub BStop_Click()
    On Error GoTo EH
    
    Form1.MousePointer = 11
    BStop.Enabled = False
    BStart.Enabled = True
    TBName.Enabled = True
    CBAction.Enabled = True
    Timer1.Enabled = False
    
    If elem.IsConnected Then
        elem.Disconnect
    End If
    
    Form1.MousePointer = 0
    Exit Sub
    
EH:
    PrintLine vbNewLine & "ERROR:"
    PrintLine Err.Description
    Form1.MousePointer = 0
End Sub


Private Sub TBName_Change()
    If Len(TBName) = 0 Then
        BStart.Enabled = False
    Else
        BStart.Enabled = True
    End If
End Sub

Private Sub Timer1_Timer()
    On Error GoTo EH
    
    Form1.MousePointer = 11
    ReturnMsg
    Form1.MousePointer = 0
    Exit Sub
    
EH:
    PrintLine vbNewLine & "ERROR:"
    PrintLine Err.Description
    Timer1.Enabled = False
    BStop_Click
End Sub

